## xeus 3.1.1

=== debian/changelog ===
xeus (3.1.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Gordon Ball <gordon@chronitis.net>  Mon, 07 Aug 2023 07:03:41 +0000

xeus (3.1.1-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Mark debian/rules as executable.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Gordon Ball ]
  * New upstream version 3.1.1
  * Rebase patches
  * Drop cppzmq dependency (moved to xeus-zmq)
  * Bump soversion libxeus6 -> libxeus9
  * Drop unused dependency on googletest

 -- Gordon Ball <gordon@chronitis.net>  Fri, 28 Jul 2023 15:49:19 +0000
