=== debian/control ===
--- 
+++ 
@@ -4,22 +4,20 @@
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               cppzmq-dev,
                xtl-dev (>= 0.7~),
                nlohmann-json3-dev,
                uuid-dev,
                libssl-dev,
                pkg-config,
-               googletest <!nocheck>,
                doctest-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/jupyter-xeus/xeus
 Vcs-Git: https://salsa.debian.org/science-team/xeus.git
 Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
-Package: libxeus6
+Package: libxeus9
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++ Implementation of the Jupyter Kernel protocol (library)
@@ -33,9 +31,8 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libxeus6 (= ${binary:Version}),
+         libxeus9 (= ${binary:Version}),
          xtl-dev,
-         cppzmq-dev,
          nlohmann-json3-dev,
          uuid-dev,
          libssl-dev,
