=== debian/changelog ===
xeus (3.1.3-2) unstable; urgency=medium

  * d/control: build-depend on nlohmann-json3-dev 3.11.3
    The API of this library exposes types from nlohmann::json, and this
    resulted in an ABI change depending on whether libxeus and the kernel
    are built against 3.11.2 or 3.11.3. This adds an explicit dependency
    on nlohmann-json3-dev 3.11.3. This explicitly chooses the newer version
    for libxeus and dependencies. (Closes: #1060164, #1061007)

 -- Gordon Ball <gordon@chronitis.net>  Sun, 11 Feb 2024 22:12:56 +0100

xeus (3.1.3-1) unstable; urgency=medium

  * New upstream version 3.1.3

 -- Gordon Ball <gordon@chronitis.net>  Thu, 05 Oct 2023 10:30:56 +0000
