=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                xtl-dev (>= 0.7~),
-               nlohmann-json3-dev,
+               nlohmann-json3-dev (>= 3.11.3~),
                uuid-dev,
                libssl-dev,
                pkg-config,
@@ -33,7 +33,7 @@
 Depends: ${misc:Depends},
          libxeus9 (= ${binary:Version}),
          xtl-dev,
-         nlohmann-json3-dev,
+         nlohmann-json3-dev (>= 3.11.3~),
          uuid-dev,
          libssl-dev,
 Description: C++ Implementation of the Jupyter Kernel protocol (headers)
