=== debian/changelog ===
xeus (5.1.1-0.1) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * New upstream release
    - New soname: libxeus9 -> libxeus11
  * debian/control:
    - Build-Depends on pkgconf instead of pkg-config.
    - New library name: libxeus9 -> libxeus11
  * debian/libxeus9.install: rename to debian/libxeus11.install

 -- Bill Allombert <ballombe@debian.org>  Fri, 27 Dec 2024 11:50:30 +0100
