=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                nlohmann-json3-dev (>= 3.11.3~),
                uuid-dev,
                libssl-dev,
-               pkg-config,
+               pkgconf,
                doctest-dev,
 Standards-Version: 4.6.1
 Section: libs
@@ -17,7 +17,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
-Package: libxeus9
+Package: libxeus11
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++ Implementation of the Jupyter Kernel protocol (library)
@@ -31,7 +31,7 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libxeus9 (= ${binary:Version}),
+         libxeus11 (= ${binary:Version}),
          xtl-dev,
          nlohmann-json3-dev (>= 3.11.3~),
          uuid-dev,
